<?php
//define class autoloader
spl_autoload_register(function($className){
    $paths=array(
        __DIR__.'/../classes/',
        __DIR__.'/../classes/core/',
        __DIR__.'/../classes/core/exception/',
        __DIR__.'/../classes/core/authentication/',
        __DIR__.'/../classes/core/interface/',
        __DIR__.'/../classes/model/',
    );
    foreach($paths as $path){
        if(file_exists($path.$className.'.class.php')){
            include_once($path.$className.'.class.php');
        }
    }
});
    
$logLevel=Log::LOGLEVEL_DEBUG;
Log::init($logLevel);

Log::write(Log::LOGLEVEL_INFO,'Importer started');


Log::write(Log::LOGLEVEL_DEBUG,'Attempting to get LIMS DB connection... ');
database::connect();
Log::write(Log::LOGLEVEL_DEBUG,'...got LIMS DB connection');


database::begin();
Log::write(Log::LOGLEVEL_DEBUG,'Initializing LIMS session...');
session::init(new DummySession());
session::set('isAdmin', true);
$user=user::getByName('genericimporter');
if(empty($user)){
    Log::write(Log::LOGLEVEL_DEBUG,'Importer user does not exist, creating...');
    $user=user::create(array(
        'name'=>'genericimporter',
        'fullname'=>'Generic Importer',
        'email'=>'genericimporter@null.null',
        'password'=>'USELESSPASSWORD',
        'isactive'=>0
    ));
    $user=$user['created'];
    Log::write(Log::LOGLEVEL_DEBUG,'...created.');
} else {
    Log::write(Log::LOGLEVEL_DEBUG,'Importer user exists.');
}
session::set('userId', $user['id']);
Log::write(Log::LOGLEVEL_DEBUG,'...Initialized LIMS session.');
database::commit();

//Include the parser
include_once __DIR__.'/GenericImporterV0_2_0.class.php';

//Get the data
$json=@file_get_contents(__DIR__.'/examplePlateGroup.json');
if(!$json){ die('Could not open JSON file for reading'); }


//Eat the data
GenericImporterV0_2_0::import($json);
